package com.book.push.controller;

/**
 * created in 2021/8/17
 * Project: book-store
 *
 * @author win7
 */

import com.book.dao.cps.pojo.AdminConfig;
import com.book.push.cons.UrlCons;
import com.book.push.service.dao.AdminConfigService;
import com.book.push.service.redis.RedisService;
import com.book.push.service.wx.WxThirdPartService;
import com.book.push.utils.Md5Util;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import me.chanjar.weixin.common.api.WxConsts;
import me.chanjar.weixin.open.api.WxOpenService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * @author
 */
@Slf4j
@RestController
@RequestMapping("/login")
public class BookIndexController {
    @Autowired
    private AdminConfigService adminConfigService;
    @Autowired
    private WxThirdPartService thirdPartService;

    @Value("${book.debug}")
    private Boolean debug;
    @Autowired
    private RedisService redisService;
    /**
     * //FIXME
     * <p>
     * 重定向urL，需要改
     */


//    @GetMapping("/{state}")
//    public String BookMain(HttpServletRequest request, @PathVariable String state) {
    @GetMapping()
    public String BookMain(HttpServletRequest request) {

        StringBuffer url = request.getRequestURL();
        String contextUrl = url.delete(url.length() - request.getRequestURI().length(), url.length()).toString();
        String[] split = contextUrl.split("\\.");
        String appid = split[0];
        if (debug) {
            appid = "wx75b8899af31a7c93";
        }
        String referer = request.getHeader("referer");
        String state = Md5Util.md5(referer);
        if (appid == null || !appid.startsWith("wx")) {



            redisService.set(state, referer, 60);
            if (referer == null) {
                log.error("非 发来源，失败 ");
                return "登录失败";
            }
            String replace = referer.replace("http://", "").replace("https://", "");
            appid = replace.split("\\.")[0];
            if (!appid.startsWith("wx")) {
                return "登录失败";
            }

        }

        AdminConfig adminConfig = adminConfigService.selectByAppid(appid);
        String redirect_url = String.format(UrlCons.OAUTH2_REDIRECT_URL_LOGIN, contextUrl);


        Integer platformId = adminConfig.getPlatformId();
        WxOpenService wxOpenService = thirdPartService.getWxOpenServiceByPlatFormId(platformId);
        String auto2Url = wxOpenService.getWxOpenComponentService().getWxMpServiceByAppid(appid).getOAuth2Service()
                .buildAuthorizationUrl(redirect_url, WxConsts.OAuth2Scope.SNSAPI_BASE, state + "_" + adminConfig.getAdminId());
        // 静默授权


        return "redirect:" + auto2Url;


    }




}
